#ifndef _INC_CSDIB32GLBASE
#define _INC_CSDIB32GLBASE


/*----------------------------------------------------------------------------*
|	SDIB32GLBase UTILITY MACROS
*----------------------------------------------------------------------------*/
// 255iK̒l256iKɕϊ}N
#define CONVERT_255To256( a ) (a+(a>>7))			// 256/255̎̔{Ō߂̍XȂœK
													// ʃrbg𗘗pĕϊ
						// (((a+1)>>8)+a)			// 255̎256ɂ
						// ((a*0x10101+0x8000)>>16) // 256/255̔{Ō߂(œK)
						// (((a<<8)+127)/255)		// 256/255̔{Ō߂

#define DEST_ALPHA( a )		(256-a)

// [vJE^ϊp
#define __DEC_WIDTH			0x10000
#define __DEC_HEIGHT		0xffff0001
#define CONVERT_WIDTH( w )	((w-1)<<16)
#define CONVERT_HEIGHT( h )	(h-1)

// `l}XN
#define __Axxx_MASK			0xff000000

// RGB }XN
#define __xRGB_MASK			0x00ffffff


/*----------------------------------------------------------------------------*
|	SDIB32GLBase Structures
*----------------------------------------------------------------------------*/
class CSDib32GLBase;
typedef CSDib32GLBase FAR* LPSDIB32GLBASE;

// TARGA Ver2.0 (32bit k `lt) wb_|\
typedef struct
{
	BYTE	No_ID;			// 0=C[Whc
	BYTE	CMap_Type;		// 0=J[}bv
	BYTE	Image_Type;		// 2=kRGB^Cv 10=kRGB^Cv
	BYTE	CMap_Spec[5];	// XLbv
	WORD	Ox;				//   X 0Œ
	WORD	Oy;				//   Y 0Œ
	WORD	Width;			//  (dot)
	WORD	Hight;			//  (dot)
	BYTE	Pixel;			// Pixel Size. 32=32bit
	BYTE	IDesc_Type;		// 8=TGA32 Agr[g

}TARGAHEADER;

// TARGA GNXeVGAŎgpt\
typedef struct
{
	short month;  //  1-12
	short day;    //  1-31
	short year;   // N 1999ƂS
	short hour;   //  0-23
	short minute; //  0-59
	short second; // b 0-59

}TARGADATE;

// TARGA GNXeVGAŎgp鎞\
typedef struct
{
	short hours;  //  0-65536
	short minute; //  0-59
	short second; // b 0-59

}TARGATIME;

// TARGA GNXeVGAŎgpL[J[\
typedef struct
{
	BYTE keyA; // L[J[.摜̃ SOȂ獕g
	BYTE keyR; // L[J[.摜̐
	BYTE keyG; // L[J[.摜̐
	BYTE keyB; // L[J[.摜̗

}TARGAKEYCOLOR;

// TARGA GNXeVGAŎgpAXyNg\
typedef struct
{
	WORD X; // hbg̃AXyNgX 0Ȃ疳
	WORD Y; // hbg̃AXyNgY 0Ȃ疳

}TARGAASPECT;

// TARGA GNXeVGAŎgp\
typedef struct
{
	WORD gammaN;  // K}l.0.0-10.0
	WORD gammaD;  // K}l.0ZbgƃK}lwȂƂȂ

}TARGAGAMMA;

// TARGA tb^[\
typedef struct
{
	DWORD	Ext_Ofs;		// 0=GNXeVGAȂ ȊO̓t@C擪AGNXeVGA܂ł̃oCg
	DWORD	Dev_Ofs;		// 0=fFbp[GAȂ@͂OŒ
	BYTE	Sign[16];		// "TRUEVISION-XFILE"Œ
	BYTE	RFU1;			// "."Œ
	BYTE	RFU2;			// NULL.0 Œ

}TARGAFOOTER;

// DIB`Xe[^X
typedef struct
{
	LONG		nDstX;			// ]XW
	LONG		nDstY;			// ]YW
	LONG		nSrcX;			// ]XW
	LONG		nSrcY;			// ]YW
	LONG		nWidth;			// ]镝
	LONG		nHeight;		// ]鍂
	LONG		nSrcAddDirX;	// ]XZ
	LONG		nSrcAddDirY;	// ]YZ
	LONG		nDstAddY;		// ]̎̃CɃANZ邽߂̃oCg

	bool		bZoom;			// gktO
	LONG		nEx;			// 덷x
	LONG		nEy;			// 덷y
	LONG		nERx;			// 덷Clx
	LONG		nERy;			// 덷Cly
	LONG		nMx;			// Xx(gk)
	LONG		nMy;			// Xy(gk)
	LONG		nSrcAddRx;		// k̓]XZ␳l
	LONG		nSrcAddRy;		// k̓]YZ␳l
	LPVOID		pLineHead;		// C̐擪AhX

}SDIB32GLSTATUS;

typedef long SDIB32GLFIXED;

// DIB]`Xe[^X
typedef struct
{
	LONG		nDstX;			// ]XW
	LONG		nDstY;			// ]YW
	LONG		nAngle;			// ]px
	LONG		nSrcX;			// ]XW
	LONG		nSrcY;			// ]YW
	union{
		SDIB32GLFIXED	fxSrcScanX;		// ]̑JnXW(Œ菬)
		SDIB32GLFIXED	fxSrcScanX_L;
	};
	union{
		SDIB32GLFIXED	fxSrcScanY;		// ]̑JnYW(Œ菬)
		SDIB32GLFIXED	fxSrcScanY_L;
	};
	LONG		nWidth;			// ]镝
	LONG		nHeight;		// ]鍂
	LONG		nDstAddY;		// ]̎̃CɃANZ邽߂̃oCg
	
	union{
		SDIB32GLFIXED	fxSrcAddXx;		// ]XxZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddXx_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddXy;		// ]XyZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddXy_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddYx;		// ]YxZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddYx_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddYy;		// ]YyZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddYy_L;
	};

	union{
		SDIB32GLFIXED	fxSrcLeft;
		LONG			nSrcLeft;
	};
	union{
		SDIB32GLFIXED	fxSrcTop;
		LONG			nSrcTop;
	};
	union{
		SDIB32GLFIXED	fxSrcRight;
		LONG			nSrcRight;
	};
	union{
		SDIB32GLFIXED	fxSrcBottom;
		LONG			nSrcBottom;
	};

	bool				b64bit;				// Œ菭64rbgtO
	SDIB32GLFIXED		fxSrcScanX_H;		// ]̑JnXW
	SDIB32GLFIXED		fxSrcScanY_H;		// ]̑JnYW
	SDIB32GLFIXED		fxSrcAddXx_H;		// ]XxZl
	SDIB32GLFIXED		fxSrcAddXy_H;		// ]XyZl
	SDIB32GLFIXED		fxSrcAddYx_H;		// ]YxZl
	SDIB32GLFIXED		fxSrcAddYy_H;		// ]YyZl

}SDIB32GLROTATESTATUS;


/*----------------------------------------------------------------------------*
|	SDib32GLBase Class
*----------------------------------------------------------------------------*/
class CSDib32GLBase : public ISDib32GL
{
protected:

	HDC					m_SorceDC;			// 쐬ΏۂłDC
	HBITMAP				m_hBitmap;			// rbg}bvnh
	HDC					m_hMemDC;			// DCnh
	LPSDIB32GLCOLOR		m_pBits;			// sNZobt@
	LPSDIB32GLCOLOR*	m_ppScanLine;		// sNZobt@̃XLC
	SDIB32GLCOLOR		m_ColorKey;			// ߐF
	DWORD				m_dwPixels;			// DIB̃sNZ
	DWORD				m_dwSizeImage;		// DIB̃TCY
	int					m_nWidth;			// DIB̕
	int					m_nHeight;			// DIB̍
	char				m_szFilePath[ _MAX_PATH ];	// ǂݍ݌̃t@CpX
	RECT				m_rcClip;			// ̃IuWFNg̃NbsÖ

	ULONG				m_ulRef;			// QƃJE^

	static	SDIB32GLCOLOR	m_MonoTbl[256];	// mNe[u

protected:

	inline STDMETHODIMP LoadBitmap( HDC hdc, FILE* fp );
	inline STDMETHODIMP LoadTarga( HDC hdc, FILE* fp );
	inline STDMETHODIMP LoadJpeg( HDC hdc, FILE* fp );
	inline STDMETHODIMP SaveBitmap( FILE* fp );
	inline STDMETHODIMP SaveTarga( FILE* fp );
	STDMETHODIMP_( bool ) Clipping( const LPSDIB32GLBASE lpSrc, SDIB32GLSTATUS& st, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP_( bool ) Clipping( const LPSDIB32GLBASE lpSrc, SDIB32GLROTATESTATUS& rst, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPPOINT lpCenterPt );
	STDMETHODIMP_( bool ) Clipping( int& nX, int& nY, int& nW, int& nH );

public:

	CSDib32GLBase();
	virtual ~CSDib32GLBase();

	/*** IUnknown methods ***/
	STDMETHODIMP QueryInterface( REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject);
	STDMETHODIMP_( ULONG ) AddRef( void );
	STDMETHODIMP_( ULONG ) Release( void );

	/*** ISDib32GL methods ***/
	STDMETHODIMP LoadFromFile( const char* lpszFileName, SDIB32GLCOLOR ColorKey, HDC hdc );
	STDMETHODIMP CreateBuffer( int nWidth, int nHeight, SDIB32GLCOLOR FillColor, HDC hdc );
	STDMETHODIMP DuplicateBuffer( LPSDIB32GL lpSDIB32GLOriginal );
	STDMETHODIMP SaveAsFile( const char* lpszFileName );

	STDMETHODIMP Blt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP ColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP RotateBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP ColorKeyToAlpha( void );
	STDMETHODIMP RGBToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP RToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP GToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP BToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP AlphaToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP ColorKeyToColorBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color );

	STDMETHODIMP SetColorKey( SDIB32GLCOLOR ColorKey ){ m_ColorKey = ColorKey; return S_OK; }
	STDMETHODIMP SetClipArea( int nX, int nY, int nW, int nH ){ RECT rc={nX,nY,nX+nW,nY+nH}; return SetClipRect(&rc); }
	STDMETHODIMP SetClipRect( LPRECT lpRect );
	STDMETHODIMP GetClipRect( LPRECT lpRect ){ if( lpRect==NULL ){ return E_POINTER; } *lpRect=m_rcClip; return S_OK; }
	STDMETHODIMP_( int ) GetWidth( void ){ return m_nWidth; }
	STDMETHODIMP_( int ) GetHeight( void ){ return m_nHeight; }
	STDMETHODIMP_( HDC ) GetDC( void ){ return m_hMemDC; }
	STDMETHODIMP_( HBITMAP ) GetBitmap( void ){ return m_hBitmap; }
	STDMETHODIMP_( LPSDIB32GLCOLOR ) GetBuffer( void ){ return m_pBits; }
	STDMETHODIMP_( LPSDIB32GLCOLOR ) GetScanLine( int nLine ){ return m_ppScanLine ? m_ppScanLine[nLine] : NULL; }
	STDMETHODIMP_( LPSDIB32GLCOLOR* ) GetScanLineBuffer( void ){ return m_ppScanLine; }
	STDMETHODIMP_( SDIB32GLCOLOR ) GetColorKey( void ){ return m_ColorKey; }
	STDMETHODIMP_( DWORD ) GetPixels( void ){ return m_dwPixels; }
	STDMETHODIMP_( DWORD ) GetSizeImage( void ){ return m_dwSizeImage; }
	STDMETHODIMP GetFileName( char* lpszFileName ){ if( lpszFileName == NULL ) return E_POINTER; ::strcpy( lpszFileName, m_szFilePath ); return S_OK; }

	STDMETHODIMP SetPixel( int x, int y, SDIB32GLCOLOR Color );
	STDMETHODIMP_( SDIB32GLCOLOR ) GetPixel( int x, int y );
	STDMETHODIMP Clear( SDIB32GLCOLOR Color );
	STDMETHODIMP Rectangle( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color );
	STDMETHODIMP Line( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color );
	STDMETHODIMP Ellipse( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color );
	STDMETHODIMP Nega( int x, int y, int nWidth, int nHeight );
	STDMETHODIMP Mosaic( int x, int y, int nWidth, int nHeight, int nBlockWidth, int nBlockHeight );
};


#endif /* _INC_CSDIB32GLBASE */