#ifndef _INC_STDAFX
#define _INC_STDAFX


/*----------------------------------------------------------------------------*
|	C/C++ RUNTIME HEADER
*----------------------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cstdarg>
#include <cmath>
#include <crtdbg.h>


/*----------------------------------------------------------------------------*
|	STL HEADER
*----------------------------------------------------------------------------*/
#pragma warning( disable : 4786 )
#include <string>
#include <map>
#pragma warning( default : 4786 )
using namespace std;


/*----------------------------------------------------------------------------*
|	WINDOWS HEADER
*----------------------------------------------------------------------------*/
#define STRICT				// Ȍ^`FbNLɂ
#define WIN32_LEAN_AND_MEAN	// Windows wb_[wǎgpȂX^btO܂
#include <windows.h>
#include <olectl.h>
#include <atlbase.h>


/*----------------------------------------------------------------------------*
|	UTILITY HEADER
*----------------------------------------------------------------------------*/
#include "sincostable.h"

/*----------------------------------------------------------------------------*
|	SDIB32GLLIB MACROS
*----------------------------------------------------------------------------*/
#define SDIB32GLLIB_VERSION	95

//#ifdef _DEBUG 
  #define safe_cast( type, expression ) dynamic_cast<type>(expression)
  #define INVALIDOBJECTCHECK( obj ) if( obj == NULL ) return SDIB32GLERR_INVALIDOBJECT;
/*#else
  #define safe_cast( type, expression ) static_cast<type>(expression)
  #define INVALIDOBJECTCHECK( obj )
#endif
*/
#define SAFE_FREE( a )			if( (a) ){ ::free( (a) ); (a)=NULL; }
#define SAFE_DELETE( a )		if( (a) ){ delete (a); (a)=NULL; }
#define SAFE_RELEASE( a )		if( (a) ){ (a)->Release(); (a)=NULL; }
#define SAFE_DELETE_ARRAY( a )	if( (a) ){ delete [] (a); (a)=NULL; }
#define SAFE_DELETE_DC( a )		if( (a) ){ ::DeleteDC( (a) ); (a)=NULL; }
#define SAFE_DELETE_OBJECT( a )	if( (a) ){ ::DeleteObject( (a) ); (a)=NULL; }


/*----------------------------------------------------------------------------*
|	SDIB32GLLIB Functions
*----------------------------------------------------------------------------*/
STDAPI_(void) SDIB32GL_DebugOutput( const char* format, ... );


#endif /* _INC_STDAFX */